 /*
  * FILE --- ga_ex.cc 
  */


// Include Files
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "ga.hh"
#include "random.hh"

#define POP_SIZE 20        // Population size
#define CHROM_LENGTH 14    // Chromosome lenght for the population
#define NUM_TRAITS 2       // Number of traits for the population



void main(void) 
{

  Population *pop = new Population(POP_SIZE, CHROM_LENGTH, NUM_TRAITS);
  Fitness_param *fitness_param = new Fitness_param();

  int max_generation = 100; // Number of Generations
  double cross_prob  = 0.9; // Probability of Crossover
  double mutat_prob  = 0.1; // Probability of Mutation */
  int elit_type      = 0;   // elitism ON/OFF 1/0
  int decode_type    = 0;   // Negative traits possible? 1=yes 0=no
  int cross_type     = 0;   // Method of crossover
  
  int trait_start[NUM_TRAITS+1] = {0, 7, CHROM_LENGTH};
  double trait_high[NUM_TRAITS] = {+7.0, +5.0};
  double trait_low[NUM_TRAITS]  = {0.0, 0.0};
  double trait_offset[NUM_TRAITS] = {-1.0, 1.0};
  int decimal[NUM_TRAITS] = {1, 1};

  int gene_high[CHROM_LENGTH] = {6,9,9,9,9,9,9,4,9,9,9,9,9,9};
  int gene_low[CHROM_LENGTH]  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0};

  //  Fit_params params;
  FILE *my_file;
  

  // Initialize Random Number Generator
  Randomize();

  // Remove previous output file
  my_file = fopen("statistics.dat","w");
  fclose(my_file);
  my_file = fopen("best_members.dat","w");
  fclose(my_file);

  // Initialize parameters
  pop->set_trait_start(trait_start);  
  pop->set_trait_offset(trait_offset);
  pop->set_trait_low(trait_low);
  pop->set_trait_high(trait_high);
  pop->set_decimal(decimal);

  pop->set_gene_low(gene_low);
  pop->set_gene_high(gene_high);

  pop->set_cross_type(cross_type);
  pop->set_cross_prob(cross_prob);
  pop->set_mutat_prob(mutat_prob);

  pop->set_elit_type(elit_type);
  pop->set_decode_type(decode_type);

  // Create the first generation
  pop->first_generation();

  //  params.example  = 0.0;  /* Initialize fitness function parameters */
  pop->find_fitness(fitness_param);
  pop->statistics("statistics.dat");
  pop->best_statistics("best_members.dat");
  
  // Create new generations
  while (pop->generation < max_generation)
    {
     //      params.example = 0.0;
      pop->next_generation();
      pop->find_fitness(fitness_param);
      pop->statistics("statistics.dat");
      pop->best_statistics("best_members.dat");
    }
  printf("\nGA complete.\n");

  pop->save_generation("last_generation.dat");
  
  delete pop;
}
